<?php

include '../core.php';

cabecera (4);

$command = $_POST['request_command'];

switch ($command) {

   default:
      echo "<h1 class='title'>Selecci&oacute;n de fichero de importaci&oacute;n de solicitudes</h1>\n";

      echo "<form method='post' action='data_import.php' enctype='multipart/form-data' name='request_import_selfile'>
      <div id='tbox'>
        <h3 class='head_a2b1'>Importacin</h3>
        <div id='tbox_data_a1'>
          <div id='trow'>
            <div id='tname'>Fichero XML:</div>
            <div id='tvalue'><input type='file' name='csrFile' size='35'></div>
          </div>
          <div id='trow'>
            <div id='tvalue'><input class='button' type='submit' value='Importar' /></div>
          </div>
        </div>
      </div>
      <input type='hidden' name='request_command' value='request_import' />
      </form>
      ";
      break;

   case "request_import":

      $cantCert = 0;
      $errorCounter = 0;

      echo "<h1 class='title'>Importaci&oacute;n de Solicitudes</h1>\n";
      // Parseamos el fichero XML en un array
      $xmlData = parseXML($csrFile);      
      $csrFileName = $_FILES['csrFile']['name'];     
 
      // Comprobamos si ha habido algun error al hacer el parser
      if ( !$xmlData ) {
         $errorDescription = $errorDescription . "Error parseando el fichero $csrFileName.";
         $errorNumber = $xmlData[0]['error'];
         $errorCounter++;       
      }
      else {
         // Obtenemos el tipo de solicitud (firma o revocacion de certificados)
         $xmlType = $xmlData[0]['xmlType'];         
         
         // Vemos cuantas solicitudes hay en el fichero
         $requestsNum = count($xmlData);

         // Para cada solicitud tendremos que generar un array y meterlo en el 
         // ldap. Empieza desde la posicion 1 de la matriz porque en la 0
         // contiene informacion del fichero en lugar de una solicitud
         for($i=1; $i < $requestsNum; $i++) {
            $errorNumber = 0;
            // Valores comunes a una CSR, RNR y una CRR
            $copaId = $xmlData[$i]['copa_id'];
            $dn = $ldapVar{rdnAttr} . "=$copaId,$base";
            $id = $xmlData[$i]['id'];
            $requestType = $xmlData[$i]['requesttype'];
            $currentDate = date("YmdHis");
                    
            // Buscamos el numero de solicitudes que hay cuyo numero copa 
            // es $copaId
            $filter = "($rdn1=$copaId)";
            $justthese = array ("count");
            $result = ldap_get_info($base, $filter, $justthese);
          
            if ($requestType == "csr" || $requestType == "rnr") {
               // Para poder insertar la CSR o la RNR en el ldap, tenemos que asegurarnos
               // de que no hay ninguna otra con ese numero copa
               if ($result["count"] != 0){
                  $errorNumber = 69; 
                  $errorCounter++;
                  $errorDescription = "\n<p>La solicitud de certificado con c&oacute;digo copa $copaId ya se ha importado anteriormente y a&uacute;n no ha sido tratada.</p>\n";
               }
               // En este caso, preparamos los datos a importar al ldap
               else { 
                  if ($requestType == "csr") 
                     $status = "csr-pending";
                  else
        	     $status = "rnr-pending";

                  // Preparamos los datos a importar al ldap
                  $navType = $xmlData[$i]['nav_type'];
                  $pkData = $xmlData[$i]['data'];
                  // Nos quedamos solo con la CSR del campo DATA
                  if ($navType == "SPKAC") {
                     list ($k, $pkCSR) = split("SPKAC", $pkData);
                     $pkCSR = "SPKAC" . $pkCSR;
                  }
                  //else if ($navType == "IE")
                  //   $pkCSR = str_replace("\r\n","",$pkData);               
                  else
                     $pkCSR = $pkData;
 
                  // Sacamos los demas valores de la matriz
                  $pkSubjectDN = $xmlData[$i]['subject_dn'];
                  $certType = $xmlData[$i]['ee_type'];
                  $pkShowMail = $xmlData[$i]['show_mail'];
                  $mail = $xmlData[$i]['mail'];
  
                  // Guardamos todas las trazas del XML en un array
                  $tracesNum = count($xmlData[$i]['traces']);

                  for($j = 0; $j < $tracesNum; $j++)
                     $info["pkirisTrace"][$j] = $xmlData[$i]['traces'][$j];
 
                  // Metemos todos los valores en un array para asi anyadirlos al ldap         
                  $info["objectClass"][0]="top";
                  $info["objectClass"][1]="irisObject";
                  $info["objectClass"][2]="pkirisCertificate";
                  $info["$rdn1"] = $copaId;
                  $info["pkirisID"] = $id;
                  $info["pkirisStatus"] = $status;
                  $info["pkirisDate"] = $currentDate;
                  $info["pkirisPin"] = "Only stored in the RA";
                  $info["pkirisCSR"] = $pkCSR;
                  $info["pkirisCertType"] = $certType;
                  $info["pkirisSubjectDN"] = $pkSubjectDN;
                  $info["pkirisCopaId"] = $copaId;
                  $info["pkirisShowMail"] = $pkShowMail;
                  $info["mail"] = $mail;
                  
                  // Escribimos los datos en el ldap
echo "## $dn ##";
print_r ($info);
                  $r = ldap_add_info($dn,$info);
  
                  if (!$r) {
                     $errorNumber = 69;
                     $errorCounter++;
                  }
               }
            }
            else if ($requestType == "crr") {
               // Si no hay ningun certificado con ese numero copa no podremos 
               // llevar a cabo la revocacion
               if ($result["count"] == 0){
                  $errorDescription = "\n<p>No existe ning&uacute;n certificado con c&oacute;digo copa $pkiCopaId.</p>\n";
                  $errorNumber = 69;
                  $errorCounter++;
               } 
               // El caso de que si exista el certificado, guardamos el motivo
               // de revocacion en la misma entrada
               else {
                  $lastStatus = getStatus($copaId);
                  $status = "crr-pending";
                 
                  // Nos aseguramos de que no se haya tratado la CRR anteriormente 
                  if ($lastStatus != $status) {
                     // Valores propios de una CRR
                     $revReason = $xmlData[$i]['reason'];
                     $revokedBy = $xmlData[$i]['revoked_by'];
                    
                     // Creamos el array con los datos a insertar en el ldap
                     $info["pkirisStatus"] = $status;
                     $info["pkirisDate"] = $currentDate;
                     $info["pkirisRevocationReason"] = $revReason;
                     $info["pkirisRevokedByCopaID"] = $revokedBy;
                     
                     $r = ldap_mod_info($dn,$info);
                     if (!$r) {
                        $errorNumber = 69;
                        $errorCounter++; 
                     }
                     else {
                        // Valores necesarios para generar la traza de una revocacion
                        $traceVals["revocationReason"] = $revReason;
                        $traceVals["invalidityDate"] = $currentDate;
                     }
                  }
                  else {
                     $errorDescription = $errorDescription . "\n<p>La solicitud de revocaci&oacute;n con n&uacute;mero copa $copaId ya se ha importado anteriormente y a&uacute;n no ha sido tratada.</p>\n";                    
                     $errorNumber = 69;
                     $errorCounter++;
                  }
               }
            }
	
            if ($errorNumber == 0) {
               // Generamos la nueva traza
               $traceVals["status"] = $status;
               $traceVals["copa"] = $copaId;
               $traceVals["currentDate"] = $currentDate;

               $pkiTrace = getTrace($traceVals);
 
               $urn["pkirisTrace"] = $pkiTrace;

               $r = ldap_mod_add_info($dn,$urn);

               if (!$r) {
                  $errorNumber = 69;
                  $errorCounter++;
               }
            }
         }
      }      
      if ($errorCounter == 0)
         echo "<p>La importaci&oacute;n se ha realizado con &eacute;xito.</p>";

      else {
         echo "<h1>Error Importando las Solicitudes</h1>
	 <p>No se ha podido completar la importaci&oacute;n de todas las solicitudes.</p>" . $errorDescription;
      }

      // Escribimos en el fichero de log los cambios de estado realizados
      $user = "CA-Admin";
      writeLog ($status, $copa, $user, $errorNumber);

   break; 
}

pie ();

?>

