<?php
# 
# Muestra una tabla con enlaces de todas las solicitudes de 
# certificado recibidas. Dichos enlaces nos enviaran a una
# pagina donde podremos consultar, aceptar o eliminar la solicitud
#
include '../../core.php';

checkAuth($raUrl);

cabecera (2);

echo "<h1>Gesti&oacute;n de solicitudes de certificados</h1>
<h2> Consulta, Aprobaci&oacute;n, Denegaci&oacute;n </h2>\n";

// Nos conectamos al servidor ldap y nos traemos el identificador, la fecha
// y el numero copa de todas las solicitudes de certificado nuevas
$filter = "(&(objectClass=pkirisCertificate)(pkirisCopaID=$raNum*)(|(pkirisStatus=new)(pkirisStatus=renew)))";
$justthese = array ("pkirisid", "pkirisdate", "pkiriscopaid");

$result = ldap_get_info ($base, $filter, $justthese);

if ($result["count"] == 0) {
   echo "<h2> No hay peticiones Nuevas </h2>";
}
   
else { // Se muestra el codigo, identificador y fecha de todas las solicitudes           
   echo "<table border='0' cellpadding='0' cellspacing='0'>
   <tr><td class='header'>C&oacute;digo de Solicitud</td><td class='header'>Identificador</td><td class='header'>Fecha</td></tr>\n";
   for($i = 0; $i < $result["count"]; $i++) {
      // Nos quedamos con el identificador copa	   
      $copa = $result[$i]["pkiriscopaid"][0];
      $ident = $result[$i]["pkirisid"][0];
      $anio = substr($result[$i]["pkirisdate"][0], 0, 4); 
      $mes = substr($result[$i]["pkirisdate"][0], 4, 2); 
      $dia = substr($result[$i]["pkirisdate"][0], 6, 2); 
      $hora = substr($result[$i]["pkirisdate"][0], 8, 2); 
      $minuto = substr($result[$i]["pkirisdate"][0], 10, 2); 
      $segundo = substr($result[$i]["pkirisdate"][0], 12, 2); 
      $fecha = $dia."/".$mes."/".$anio." - ".$hora.":".$minuto.":".$segundo;
      if ($i%2==0) {
         echo "<tr><td class='even'><a href='csr_manage.php?copa=$copa?$ident?$fecha'>  ". $copa ."  </a></td><td class='even'> $ident </td><td class='even'>  ". $fecha ."  </td></tr>";
      }
      else {
         echo "<tr><td class='odd'><a href='csr_manage.php?copa=$copa?$ident?$fecha'>  ". $copa ."  </a></td><td class='odd'> $ident </td><td class='odd'>  ". $fecha ."  </td></tr>";
      }
   }  
   echo "</table>\n";
}

pie ();

?>

